import express from "express";
import * as mongoose from "mongoose";
import { API_PORT, MONGO_URL } from "./config/contants";

const app = express();

// Routes
const userRoute = require("./routes/user");

// Environment constants

// Service Initialisation
mongoose.connect(MONGO_URL, {
  useFindAndModify: false,
  useNewUrlParser: true,
  useUnifiedTopology: true,
});

// Express Initialisation
app.use(express.urlencoded({ extended: true }));
app.use(express.json());

app.use(express.urlencoded({ extended: false }));

// Routes
app.use("/user", userRoute);

app.listen(API_PORT, () => console.log(`Listening on port ${API_PORT}`));
