import { Request, Response, NextFunction } from "express";
import * as jwt from "jsonwebtoken";
import { JWT_SECRET } from "../config/contants";

export const authMiddleware = (
  req: Request,
  res: Response,
  next: NextFunction
) => {
  const token = req.header("Authorization");

  if (!token) {
    return res.status(401).send("Authorization denied");
  } else {
    const decodedToken = <jwt.JwtPayload>jwt.verify(token, JWT_SECRET);
    if (decodedToken) {
      req.query.id = decodedToken.id;
      return next();
    } else {
      return res.status(401).send("Unauthorized Access");
    }
  }
};
